#!/usr/bin/env python
#-*- coding=utf-8 -*-

try:
    import pygtk
    pygtk.require("2.0")
except Exception, detail:
    print "You do not have a recent version of GTK"

try:
    import os
    import sys
    import shutil
    import commands
    import gtk
    import gtk.glade
    import gettext
    import string
    import Parser_LPMT
    import Check_LPMT
    import thread
    import zipfile
    import time
    import thread
    import dbus
    import dbus.mainloop.glib
except Exception, detail:
    print "You do not have the required dependencies"

# i18n
gettext.install("lpmt", "/usr/share/lpmt/locale")
#gettext.install("lpmt", "../../share/lpmt/locale")

# i18n for menu item
menuName = _("Log Parser Management Tool")
menuComment = _("Make a statistics of log")

DBUS_PATH='/com/nfs/LpmtService'
DBUS_NAME='com.nfs.LpmtService'
DBUS_INTERFACES='com.nfs.LpmtService'

''' The main class of the app '''
class LPMT:

    ''' New Log Parser Management Tool '''
    def __init__(self):
        self.show_loding_win()
        self.zip_filename = ''
        self.export_result = False
        dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
        self.system_dbus=dbus.SystemBus()
        self.lpmt_dbus=self.system_dbus.get_object('com.nfs.LpmtService', '/com/nfs/LpmtService')
        self.system_dbus.add_signal_receiver(self.handle_export_success, "exportLogsSuccess", DBUS_INTERFACES, DBUS_NAME, DBUS_PATH)
        self.system_dbus.add_signal_receiver(self.handle_export_failed, "exportLogsFailed", DBUS_INTERFACES, DBUS_NAME, DBUS_PATH)
        # self.lpmt_dbus.connect_to_signal("exportLogsFinished", self.export_finished, dbus_interface=DBUS_INTERFACES, arg0=self, arg1="exportLogsFinished")

    def show_loding_win(self):
        self.loading_win = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.loading_win.modify_bg(gtk.WINDOW_TOPLEVEL, gtk.gdk.Color('#000000'))
        self.loading_win.set_size_request(120,120)
        self.loading_win.set_position(gtk.WIN_POS_CENTER)
        self.loading_win.set_type_hint(gtk.gdk.WINDOW_TYPE_HINT_COMBO)
        self.loading_frame = gtk.Frame()
        self.loading_image = gtk.Image()
        self.loading_image.set_from_file("/usr/lib/lpmt/loading.gif")
        self.loading_frame.add(self.loading_image)
        self.loading_win.add(self.loading_frame)
        self.loading_frame.show()
        self.loading_image.show()
        self.loading_win.show()

    def show_export_win(self,widget):
        self.loading_win.destroy()
        self.export_win = gtk.Window(gtk.WINDOW_TOPLEVEL)
        self.export_win.modify_bg(gtk.WINDOW_TOPLEVEL, gtk.gdk.Color('#000000'))
        self.export_win.set_title("提示信息")
        self.export_win.set_size_request(400, 100)
        self.export_win.set_position(gtk.WIN_POS_CENTER)
        self.export_win.set_border_width(5)
        self.export_win.set_resizable(False)
        self.lable_info = gtk.Label()
        if self.export_result:
            filepath = os.environ['HOME'] + "/桌面"
            self.lable_info.set_text("导出成功！\n\n日志路径：" + filepath + "\n\n日志名称：" + self.zip_filename)
        else:
            self.lable_info.set_text("导出失败！")
        self.lable_info.set_size_request(80, 50)
        self.export_win.add(self.lable_info)
        self.lable_info.show()
        self.export_win.show()

    def do_main_window_init(self):

        scale_output = os.popen("gsettings get org.cdos.desktop.interface scaling-factor | awk '{print $2}'")
        scale = scale_output.read().strip('\n')
        if (scale == "2"):
            self.glade = '/usr/lib/lpmt/lpmt2k.glade'
        else:
            self.glade = '/usr/lib/lpmt/lpmt.glade'
        #self.glade = 'lpmt.glade'
        self.wTree = gtk.glade.XML(self.glade, 'main_window')

        # handle command line filenames
        if(len(sys.argv) > 1):
            print "usage: " + sys.argv[0]
            sys.exit(1)
        #parser for logs
        parser = Parser_LPMT.Parser_LPMT()
        self.check_parser = Check_LPMT.Check_LPMT()

        #flag for menu,0 for menu_view,1 for menu_analyze
        self.flag_menu = 0

        # info of wtmp
        self.wtmp_year = []
        self.wtmp_content = []
        self.wtmp_content_formated = []
        self.time_list = []
        self.times_for_years = []

        #item number
        self.number_for_wtmp = 0
        self.number_for_times = 0
        self.number_for_boot = 0
        self.number_for_kern = 0
        self.number_for_dpkg = 0
        self.number_for_sys = 0
        self.number_for_auth = 0
        self.number_for_alter = 0
        self.number_for_ufw = 0
        self.number_for_cups = 0
        self.number_for_brasero = 0
        self.number_for_audit = 0
        self.number_for_xsession = 0
        self.number_for_dmesg = 0
        self.number_for_fail = 0
        self.number_for_xorg = 0
        self.number_for_bios = 0
        self.number_for_sscard = 0

        self.number_for_debug = 0
        self.number_for_info = 0
        self.number_for_notice = 0
        self.number_for_warning = 0
        self.number_for_err = 0
        self.number_for_crit = 0
        self.number_for_alert = 0
        self.number_for_emerg = 0

        #item count
        self.count_for_wtmp = 0
        self.count_for_times = 0
        self.count_for_boot = 0
        self.count_for_kern = 0
        self.count_for_dpkg = 0
        self.count_for_sys = 0
        self.count_for_auth = 0
        self.count_for_alter = 0
        self.count_for_ufw = 0
        self.count_for_cups = 0
        self.count_for_brasero = 0
        self.count_for_audit = 0
        self.count_for_xsession = 0
        self.count_for_dmesg = 0
        self.count_for_fail = 0
        self.count_for_xorg = 0
        self.count_for_bios = 0
        self.count_for_sscard = 0

        self.count_for_debug = 0
        self.count_for_info = 0
        self.count_for_notice = 0
        self.count_for_warning = 0
        self.count_for_err = 0
        self.count_for_crit = 0
        self.count_for_alert = 0
        self.count_for_emerg = 0

        #load flag
        self.load_boot_flag = 0
        self.load_kern_flag = 0
        self.load_dpkg_flag = 0
        self.load_sys_flag = 0
        self.load_auth_flag = 0
        self.load_alter_flag = 0
        self.load_ufw_flag = 0
        self.load_cups_flag = 0
        self.load_brasero_flag = 0
        self.load_audit_flag = 0
        self.load_xsession_flag = 0
        self.load_dmesg_flag = 0
        self.load_fail_flag = 0
        self.load_xorg_flag = 0
        self.load_bios_flag = 0
        self.load_sscard_flag = 0

        self.load_debug_flag = 0
        self.load_info_flag = 0
        self.load_notice_flag = 0
        self.load_warning_flag = 0
        self.load_err_flag = 0
        self.load_crit_flag = 0
        self.load_alert_flag = 0
        self.load_emerg_flag = 0


        #parse flag
        self.parse_dmesg_flag = 0
        self.parse_auth_flag = 0        
        self.parse_sys_flag = 0
        self.parse_boot_flag = 0
        self.parse_dpkg_flag = 0        
        self.parse_kern_flag = 0
        self.parse_alter_flag = 0        
        self.parse_cups_flag = 0
        self.parse_brasero_flag = 0 
        self.parse_audit_flag = 0 
        self.parse_xsession_flag = 0       
        self.parse_ufw_flag = 0
        self.parse_fail_flag = 0
        self.parse_xorg_flag = 0
        self.parse_bios_flag = 0
        self.parse_sscard_flag = 0

        self.parse_level_debug_flag = 0
        self.parse_level_info_flag = 0
        self.parse_level_notice_flag = 0
        self.parse_level_warning_flag = 0
        self.parse_level_err_flag = 0
        self.parse_level_crit_flag = 0
        self.parse_level_alert_flag = 0
        self.parse_level_emerg_flag = 0
        

        #used for pages turning
        self.twopage_count1 = 20000
        self.twopage_count2 = 20000
        self.item_count1 = 10000
        self.item_count2 = 10000
        

        self.twopage_count = self.twopage_count1
        self.items_one_page = self.item_count1

        #list loaded into user interface 
        self.load_wtmp_list = []
        self.load_times_list = []
        self.load_boot_list = []
        self.load_kern_list = []
        self.load_dpkg_list = []
        self.load_sys_list = []
        self.load_auth_list = []
        self.load_alter_list = []
        self.load_ufw_list = []
        self.load_cups_list = []
        self.load_brasero_list = []
        self.load_audit_list = []
        self.load_xsession_list = []
        self.load_dmesg_list = []
        self.load_fail_list = []
        self.load_xorg_list = []
        self.load_bios_list = []
        self.load_sscard_list = []

        self.load_debug_list = []
        self.load_info_list = []
        self.load_notice_list = []
        self.load_warning_list = []
        self.load_err_list = []
        self.load_crit_list = []
        self.load_alert_list = []
        self.load_emerg_list = []

        #keyword for every list
        self.keyword_wtmp = ''
        self.keyword_times = ''
        self.keyword_boot = ''
        self.keyword_kern = ''
        self.keyword_dpkg = ''
        self.keyword_sys = ''
        self.keyword_auth = ''
        self.keyword_alter = ''
        self.keyword_ufw = ''
        self.keyword_cups = ''
        self.keyword_brasero = ''
        self.keyword_audit = ''
        self.keyword_xsession = ''
        self.keyword_dmesg = ''
        self.keyword_fail = ''
        self.keyword_xorg = ''
        self.keyword_bios = ''
        self.keyword_sscard = ''

        self.keyword_debug = ''
        self.keyword_info = ''
        self.keyword_notice = ''
        self.keyword_warning = ''
        self.keyword_err = ''
        self.keyword_crit = ''
        self.keyword_alert = ''
        self.keyword_emerg = ''

        #current year and month
        self.year_for_wtmp = 0
        self.month_for_wtmp = 0
        self.year_for_times = 0
        self.month_for_times = 0

        #page0
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=3)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_all").append_column(column)

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=3)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_all").append_column(column)

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=3)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_all").append_column(column)

        #page1
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Year"), ren, background=4)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_times").append_column(column)
        self.wTree.get_widget("treeview_times").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Month"), ren, background=4)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_times").append_column(column)
        self.wTree.get_widget("treeview_times").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Reboot times"), ren, background=4)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_times").append_column(column)
        self.wTree.get_widget("treeview_times").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Shutdown times"), ren, background=4)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_times").append_column(column)
        self.wTree.get_widget("treeview_times").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page2
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=5)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_sys").append_column(column)
        self.wTree.get_widget("treeview_sys").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=5)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_sys").append_column(column)
        self.wTree.get_widget("treeview_sys").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=5)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_sys").append_column(column)
        self.wTree.get_widget("treeview_sys").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=5)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_sys").append_column(column)
        self.wTree.get_widget("treeview_sys").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=5)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_sys").append_column(column)
        self.wTree.get_widget("treeview_sys").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page3
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=2)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_boot").append_column(column)
        self.wTree.get_widget("treeview_boot").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=2)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_boot").append_column(column)
        self.wTree.get_widget("treeview_boot").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page4
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=4)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_dpkg").append_column(column)
        self.wTree.get_widget("treeview_dpkg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=4)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_dpkg").append_column(column)
        self.wTree.get_widget("treeview_dpkg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("State"), ren, background=4)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_dpkg").append_column(column)
        self.wTree.get_widget("treeview_dpkg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Package"), ren, background=4)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_dpkg").append_column(column)
        self.wTree.get_widget("treeview_dpkg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page5
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=4)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_kern").append_column(column)
        self.wTree.get_widget("treeview_kern").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=4)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_kern").append_column(column)
        self.wTree.get_widget("treeview_kern").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=4)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_kern").append_column(column)
        self.wTree.get_widget("treeview_kern").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=4)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_kern").append_column(column)
        self.wTree.get_widget("treeview_kern").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page6
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=3)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_alter").append_column(column)
        self.wTree.get_widget("treeview_alter").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=3)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_alter").append_column(column)
        self.wTree.get_widget("treeview_alter").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=3)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_alter").append_column(column)
        self.wTree.get_widget("treeview_alter").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page7
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=6)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_cups").append_column(column)
        self.wTree.get_widget("treeview_cups").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=6)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_cups").append_column(column)
        self.wTree.get_widget("treeview_cups").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=6)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_cups").append_column(column)
        self.wTree.get_widget("treeview_cups").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("User"), ren, background=6)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_cups").append_column(column)
        self.wTree.get_widget("treeview_cups").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=6)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_cups").append_column(column)
        self.wTree.get_widget("treeview_cups").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=6)
        column.add_attribute(ren, "text", 5)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_cups").append_column(column)
        self.wTree.get_widget("treeview_cups").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page8
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=1)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_brasero").append_column(column)
        self.wTree.get_widget("treeview_brasero").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page9
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=1)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_audit").append_column(column)
        self.wTree.get_widget("treeview_audit").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page10
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=1)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_xsession").append_column(column)
        self.wTree.get_widget("treeview_xsession").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page11
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Load time"), ren, background=2)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_xorg").append_column(column)
        self.wTree.get_widget("treeview_xorg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=2)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_xorg").append_column(column)
        self.wTree.get_widget("treeview_xorg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page12
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=1)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_bios").append_column(column)
        self.wTree.get_widget("treeview_bios").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page13
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=1)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_sscard").append_column(column)
        self.wTree.get_widget("treeview_sscard").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page14
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=5)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_debug").append_column(column)
        self.wTree.get_widget("treeview_debug").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=5)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_debug").append_column(column)
        self.wTree.get_widget("treeview_debug").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=5)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_debug").append_column(column)
        self.wTree.get_widget("treeview_debug").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=5)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_debug").append_column(column)
        self.wTree.get_widget("treeview_debug").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=5)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_debug").append_column(column)
        self.wTree.get_widget("treeview_debug").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page info
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=5)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_info").append_column(column)
        self.wTree.get_widget("treeview_info").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=5)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_info").append_column(column)
        self.wTree.get_widget("treeview_info").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=5)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_info").append_column(column)
        self.wTree.get_widget("treeview_info").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=5)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_info").append_column(column)
        self.wTree.get_widget("treeview_info").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=5)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_info").append_column(column)
        self.wTree.get_widget("treeview_info").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page notice
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=5)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_notice").append_column(column)
        self.wTree.get_widget("treeview_notice").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=5)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_notice").append_column(column)
        self.wTree.get_widget("treeview_notice").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=5)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_notice").append_column(column)
        self.wTree.get_widget("treeview_notice").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=5)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_notice").append_column(column)
        self.wTree.get_widget("treeview_notice").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=5)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_notice").append_column(column)
        self.wTree.get_widget("treeview_notice").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page warning
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=5)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_warning").append_column(column)
        self.wTree.get_widget("treeview_warning").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=5)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_warning").append_column(column)
        self.wTree.get_widget("treeview_warning").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=5)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_warning").append_column(column)
        self.wTree.get_widget("treeview_warning").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=5)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_warning").append_column(column)
        self.wTree.get_widget("treeview_warning").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=5)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_warning").append_column(column)
        self.wTree.get_widget("treeview_warning").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page err
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=5)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_err").append_column(column)
        self.wTree.get_widget("treeview_err").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=5)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_err").append_column(column)
        self.wTree.get_widget("treeview_err").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=5)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_err").append_column(column)
        self.wTree.get_widget("treeview_err").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=5)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_err").append_column(column)
        self.wTree.get_widget("treeview_err").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=5)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_err").append_column(column)
        self.wTree.get_widget("treeview_err").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page crit
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=5)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_crit").append_column(column)
        self.wTree.get_widget("treeview_crit").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=5)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_crit").append_column(column)
        self.wTree.get_widget("treeview_crit").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=5)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_crit").append_column(column)
        self.wTree.get_widget("treeview_crit").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=5)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_crit").append_column(column)
        self.wTree.get_widget("treeview_crit").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=5)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_crit").append_column(column)
        self.wTree.get_widget("treeview_crit").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page alert
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=5)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_alert").append_column(column)
        self.wTree.get_widget("treeview_alert").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=5)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_alert").append_column(column)
        self.wTree.get_widget("treeview_alert").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=5)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_alert").append_column(column)
        self.wTree.get_widget("treeview_alert").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=5)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_alert").append_column(column)
        self.wTree.get_widget("treeview_alert").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=5)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_alert").append_column(column)
        self.wTree.get_widget("treeview_alert").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        #page emerg
        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Date"), ren, background=5)
        column.add_attribute(ren, "text", 0)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_emerg").append_column(column)
        self.wTree.get_widget("treeview_emerg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Time"), ren, background=5)
        column.add_attribute(ren, "text", 1)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_emerg").append_column(column)
        self.wTree.get_widget("treeview_emerg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Hostname"), ren, background=5)
        column.add_attribute(ren, "text", 2)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_emerg").append_column(column)
        self.wTree.get_widget("treeview_emerg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Action"), ren, background=5)
        column.add_attribute(ren, "text", 3)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_emerg").append_column(column)
        self.wTree.get_widget("treeview_emerg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        ren = gtk.CellRendererText()
        column = gtk.TreeViewColumn(_("Description"), ren, background=5)
        column.add_attribute(ren, "text", 4)
        column.set_resizable(True)
        self.wTree.get_widget("treeview_emerg").append_column(column)
        self.wTree.get_widget("treeview_emerg").set_model(gtk.ListStore(str, gtk.gdk.Pixbuf))

        # nav buttons
        #self.wTree.get_widget("button_lastpage").connect("clicked", self.last_callback)
        #self.wTree.get_widget("button_nextpage").connect("clicked", self.next_callback)
        self.wTree.get_widget("button_export_current").connect("clicked", self.export_current_callback)
        self.wTree.get_widget("button_export_all").connect("clicked", self.export_all_callback)
        #self.wTree.get_widget("button_jumpto").connect("clicked", self.jumppage_callback)
        self.wTree.get_widget("button_search").connect("clicked", self.filter_statistics_callback)
        self.wTree.get_widget("button_close").connect("clicked", self.cancel_callback)

        #entry
        self.wTree.get_widget("entry_keyword").connect("activate", self.filter_statistics_callback)
        #self.wTree.get_widget("entry_page").connect("activate", self.jumppage_callback)

        self.wTree.get_widget("main_window").connect("destroy", self.cancel_callback)
        self.wTree.get_widget("main_window").set_title(_("nfs-log"))

        #menuitems and labels
        time_item = gtk.MenuItem(_("Last search"))
        time_item.show()
        self.wTree.get_widget("menu_view").append(time_item)
        time_item.connect("activate", self.change_notebook)

        sys_item = gtk.MenuItem(_("Sys statistics"))
        sys_item.show()
        # self.wTree.get_widget("menu_view").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#ffffff'))
        self.wTree.get_widget("menu_view").append(sys_item)
        sys_item.connect("activate", self.change_notebook)

        boot_item = gtk.MenuItem(_("Boot statistics"))
        boot_item.show()
        self.wTree.get_widget("menu_view").append(boot_item)
        boot_item.connect("activate", self.change_notebook)

        dpkg_item = gtk.MenuItem(_("Dpkg statistics"))
        dpkg_item.show()
        self.wTree.get_widget("menu_view").append(dpkg_item)
        dpkg_item.connect("activate", self.change_notebook)

        kern_item = gtk.MenuItem(_("Kern statistics"))
        kern_item.show()
        self.wTree.get_widget("menu_view").append(kern_item)
        kern_item.connect("activate", self.change_notebook)

        alt_item = gtk.MenuItem(_("Alternative statistics"))
        alt_item.show()
        self.wTree.get_widget("menu_view").append(alt_item)
        alt_item.connect("activate", self.change_notebook)

        cups_item = gtk.MenuItem(_("Cups statistics"))
        cups_item.show()
        self.wTree.get_widget("menu_view").append(cups_item)
        cups_item.connect("activate", self.change_notebook)

        brasero_item = gtk.MenuItem(_("Brasero statistics"))
        brasero_item.show()
        self.wTree.get_widget("menu_view").append(brasero_item)
        brasero_item.connect("activate", self.change_notebook)

        audit_item = gtk.MenuItem(_("Audit statistics"))
        audit_item.show()
        self.wTree.get_widget("menu_view").append(audit_item)
        audit_item.connect("activate", self.change_notebook)

        xsession_item = gtk.MenuItem(_("Xsession statistics"))
        xsession_item.show()
        self.wTree.get_widget("menu_view").append(xsession_item)
        xsession_item.connect("activate", self.change_notebook)

        xorg_item = gtk.MenuItem(_("Xorg statistics"))
        xorg_item.show()
        self.wTree.get_widget("menu_view").append(xorg_item)
        xorg_item.connect("activate", self.change_notebook)

        zy_path = "/var/log/sscard/.scdlog"
        if os.path.exists(zy_path):
            bios_audit_item = gtk.MenuItem(_("Bios audit statistics"))
            bios_audit_item.show()
            self.wTree.get_widget("menu_view").append(bios_audit_item)
            bios_audit_item.connect("activate", self.change_notebook)

            sscard_item = gtk.MenuItem(_("Sscard statistics"))
            sscard_item.show()
            self.wTree.get_widget("menu_view").append(sscard_item)
            sscard_item.connect("activate", self.change_notebook)

        level_debug_item = gtk.MenuItem(_("debug"))
        level_debug_item.show()
        # self.wTree.get_widget("menu_level").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#ffffff'))
        self.wTree.get_widget("menu_level").append(level_debug_item)
        level_debug_item.connect("activate",self.change_notebook)

        level_info_item = gtk.MenuItem(_("info"))
        level_info_item.show()
        self.wTree.get_widget("menu_level").append(level_info_item)
        level_info_item.connect("activate",self.change_notebook)

        level_notice_item = gtk.MenuItem(_("notice"))
        level_notice_item.show()
        self.wTree.get_widget("menu_level").append(level_notice_item)
        level_notice_item.connect("activate",self.change_notebook)

        level_warning_item = gtk.MenuItem(_("warning"))
        level_warning_item.show()
        self.wTree.get_widget("menu_level").append(level_warning_item)
        level_warning_item.connect("activate",self.change_notebook)

        level_err_item = gtk.MenuItem(_("err"))
        level_err_item.show()
        self.wTree.get_widget("menu_level").append(level_err_item)
        level_err_item.connect("activate",self.change_notebook)

        level_crit_item = gtk.MenuItem(_("crit"))
        level_crit_item.show()
        self.wTree.get_widget("menu_level").append(level_crit_item)
        level_crit_item.connect("activate",self.change_notebook)

        level_alert_item = gtk.MenuItem(_("alert"))
        level_alert_item.show()
        self.wTree.get_widget("menu_level").append(level_alert_item)
        level_alert_item.connect("activate",self.change_notebook)

        level_emerg_item = gtk.MenuItem(_("emerg"))
        level_emerg_item.show()
        self.wTree.get_widget("menu_level").append(level_emerg_item)
        level_emerg_item.connect("activate",self.change_notebook)

        all_syslog_item = gtk.MenuItem(_("all system logs"))
        all_syslog_item.show()
        self.wTree.get_widget("menu_collect_log").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#ffffff'))
        self.wTree.get_widget("menu_collect_log").append(all_syslog_item)
        all_syslog_item.connect("activate",self.export_all_system_logs)

        all_print_log_item = gtk.MenuItem(_("print related logs"))
        all_print_log_item.show()
        self.wTree.get_widget("menu_collect_log").append(all_print_log_item)
        all_print_log_item.connect("activate",self.export_all_print_logs)

        times_item = gtk.MenuItem(_("Times statistics"))
        times_item.show()
        self.wTree.get_widget("menu_analyze").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#ffffff'))
        self.wTree.get_widget("menu_analyze").append(times_item)
        times_item.connect("activate", self.change_notebook)

        self.wTree.get_widget("imagemenuitem_help").connect("activate", self.about_callback)

        self.wTree.get_widget("label_logtitle").set_text(_("Last search"))
        self.wTree.get_widget("label_year").set_text(_("Keyword year"))
        self.wTree.get_widget("label_month").set_text(_("Keyword month"))
        self.wTree.get_widget("label_keyword").set_text(_("Keyword for search"))
        self.wTree.get_widget("label_jumpto").set_text(_("Jump to"))
        self.wTree.get_widget("label_page").set_text(_("page"))
        self.wTree.get_widget("button_search").set_label(_("Search"))

        #搜索按钮的中文名字
        self.wTree.get_widget("button_search").set_label(_("Search"))
        #搜索按钮的背景颜色
        self.wTree.get_widget("button_search").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#dddddd'))
        #导出当前日志背景颜色
        self.wTree.get_widget("button_export_current").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#dddddd'))
        #导出所有日志背景颜色
        self.wTree.get_widget("button_export_all").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#dddddd'))
        #关闭按钮背景颜色
        self.wTree.get_widget("button_close").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#dddddd'))
        #一级菜单栏背景颜色
        self.wTree.get_widget("menubar1").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#ffffff'))
        #主窗口背景颜色
        self.wTree.get_widget("main_window").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#ffffff'))
        #二级菜单关于按钮背景颜色
        self.wTree.get_widget("menu_help").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#ffffff'))
        
        #关于背景颜色
        self.wTree.get_widget("imagemenuitem_help").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#ffffff'))

        comps = gtk.ListStore(str)
        comps.append(["\xe6\x89\x80\xe6\x9c\x89"])
        self.get_info("/var/log/wtmp")
        for year in self.wtmp_year:
            comps.append([year])
        self.wTree.get_widget("combobox_year").set_model(comps)
        self.wTree.get_widget("combobox_year").set_active(0)
        self.wTree.get_widget("combobox_year").connect("changed", self.filter_statistics_callback)

        comps = gtk.ListStore(str)
        comps.append(["\xe6\x89\x80\xe6\x9c\x89"])
        #comps.append([None])
        comps.append(["1"])
        comps.append(["2"])
        comps.append(["3"])
        comps.append(["4"])
        comps.append(["5"])
        comps.append(["6"])
        comps.append(["7"])
        comps.append(["8"])
        comps.append(["9"])
        comps.append(["10"])
        comps.append(["11"])
        comps.append(["12"])

        self.wTree.get_widget("combobox_month").set_model(comps)
        self.wTree.get_widget("combobox_month").modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#ffffff'))
        self.wTree.get_widget("combobox_month").set_active(0)
        self.wTree.get_widget("combobox_month").connect("changed", self.filter_statistics_callback)

        #get information of wtmp
        self.format_wtmp_content()
        self.get_times()
        self.load_wtmp_list = self.time_list[:]
        self.load_times_list = self.times_for_years[:]

        #initialize times statistics treeview
        self.load_times(f=1, start = 0, end = 0)

        #initialize time statistics treeview with the rescent record--24 items
        self.load_wtmp(f=1, start = 0, end = 0)

        #initialize page label
        self.update_pagelabel(self.number_for_wtmp ,self.count_for_wtmp)

        #initialize two button
        self.count_for_wtmp = len(self.load_wtmp_list)
        if self.count_for_wtmp <= self.items_one_page:
            self.wTree.get_widget("button_nextpage").hide()
        self.wTree.get_widget("button_lastpage").hide()

        self.wTree.get_widget("main_window").show()
        self.loading_win.destroy()

    ''' Get output of os command '''
    def execCmd(self,cmd):
        try:
            r = os.popen(cmd)
            lines = r.readlines()
            r.close()
        except Exception, detail:
            print detail
        return lines

    ''' Get shutdown and reboot times for each year and each month'''
    def get_times(self):
        for year in self.wtmp_year:
            reboot_shutdown_count = [[0,0],[0,0],[0,0],
                                     [0,0],[0,0],[0,0],
                                     [0,0],[0,0],[0,0],
                                     [0,0],[0,0],[0,0]]
            for content in self.wtmp_content_formated:
                if content.get('year') == year:
                    if content.get('action') == 'reboot':
                        reboot_shutdown_count[string.atoi(content.get('month'))-1][0] = 1 + reboot_shutdown_count[string.atoi(content.get('month'))-1][0]
                    else:
                        reboot_shutdown_count[string.atoi(content.get('month'))-1][1] = 1 + reboot_shutdown_count[string.atoi(content.get('month'))-1][1]
            for month in [0,1,2,3,4,5,6,7,8,9,10,11]:
                if reboot_shutdown_count[month][0] + reboot_shutdown_count[month][1] != 0:
                    self.count_for_times += 1
                    self.times_for_years.append({'year':year, 'month':str(month+1), 'reboot':str(reboot_shutdown_count[month][0]), 'shutdown':str(reboot_shutdown_count[month][1])})

    ''' Get information of wtmp '''
    def get_info(self,logname):
        if logname == "/var/log/wtmp":
            tmpname = logname
            n = 0
            while True:
                if os.path.exists(tmpname):
                    lines = self.execCmd("last -x -F -f " + tmpname + " | grep -v runlevel | grep -v wtmp | grep -v ^$")
                    if len(lines) > 0:
                        self.wtmp_content.append(lines)
                        yearline = lines[-1]
                        year = yearline.rstrip("\n").split()[-2]
                        self.wtmp_year.append(year)
                else:
                    break
                n += 1
                tmpname = logname + '.' + str(n)
            tmp_year = []
            for year in list(set(self.wtmp_year)):
                tmp_year.append(year)
            self.wtmp_year = tmp_year

    '''Format wtmp's content'''
    def format_wtmp_content(self):
        for content in self.wtmp_content:
            for c in content:
                if c.find('reboot') >= 0 or c.find('shutdown') >= 0:
                    year_index = 8
		    day_index = 6
                    time_index = 7
                    month_index = 5
                if c.find('tty') >= 0 :
                    year_index = 7
		    day_index = 5
                    time_index = 6
                    month_index = 4
                content_line = c.split()
                if c.find('tty') >= 0 :
                    content_line[0] = content_line[0] + " 用户登录"
                print(content_line)
                if content_line[month_index] == 'Jan':
                    month = '1'
                elif content_line[month_index] == 'Feb':
                    month = '2'
                elif content_line[month_index] == 'Mar':
                    month = '3'
                elif content_line[month_index] == 'Apr':
                    month = '4'
                elif content_line[month_index] == 'May':
                    month = '5'
                elif content_line[month_index] == 'Jun':
                    month = '6'
                elif content_line[month_index] == 'Jul':
                    month = '7'
                elif content_line[month_index] == 'Aug':
                    month = '8'
                elif content_line[month_index] == 'Sep':
                    month = '9'
                elif content_line[month_index] == 'Oct':
                    month = '10'
                elif content_line[month_index] == 'Nov':
                    month = '11'
                else:
                    month = '12'
                self.wtmp_content_formated.append({'year':content_line[year_index],'month':month,'day':content_line[day_index],'time':content_line[time_index],'action':content_line[0]})
                self.time_list.append({'date':content_line[year_index]+'-'+month+'-'+content_line[day_index],'time':content_line[time_index],'action':content_line[0]})
        self.count_for_wtmp = len(self.time_list)


    ''' Cancel clicked '''
    def cancel_callback(self, widget):
        # just quit :)
        gtk.main_quit()

    ''' show the pretty aboutbox. '''
    def about_callback(self, w):
        dlg = gtk.AboutDialog()
        dlg.set_title(_("About"))
        dlg.set_size_request(400, 250)
        dlg.modify_bg(gtk.STATE_NORMAL, gtk.gdk.Color('#ffffff'))
        dlg.set_program_name(_("Log Parser Management Tool"))

        try:
            version = os.popen("/usr/lib/lpmt/version.py lpmt")
            ret = version.read()
            version.close()
            dlg.set_version(ret)
        except Exception as detail:
            print(detail)
        dlg.set_logo(gtk.gdk.pixbuf_new_from_file("/usr/lib/lpmt/icon.png"))
        dlg.set_comments("日志分析换里工具是一款支持系统、应用等相关日志信息查看、统计、分析、导出的管理工具。")
        dlg.set_copyright("© 2022 中科方德软件有限公司")
        def close(w, res):
            if res == gtk.RESPONSE_CANCEL:
                w.hide()
        dlg.connect("response", close)
        dlg.show()
        '''
        try:
            h = open('/usr/share/common-licenses/GPL','r')
            s = h.readlines()
            gpl = ""
            for line in s:
                gpl += line
            h.close()
            gpl = "\xe7\x89\x88\xe6\x9d\x83\xe6\x89\x80\xe6\x9c\x89:\xe4\xb8\xad\xe7\xa7\x91\xe6\x96\xb9\xe5\xbe\xb7"
            dlg.set_license(gpl)
        except Exception, detail:
            print detail
        try:
            version = commands.getoutput("/usr/lib/lpmt/version.py lpmt")
            dlg.set_version(version)
        except Exception, detail:
            print detail

        dlg.set_authors(["Dayong Wang <dayong@nfschina.com>", "Zhengxian Shi <zhengxian@nfschina.com>"])
        dlg.set_icon_from_file("/usr/lib/lpmt/icon.png")
        dlg.set_logo(gtk.gdk.pixbuf_new_from_file("/usr/lib/lpmt/icon.svg"))
        def close(w, res):
            if res == gtk.RESPONSE_CANCEL:
                w.hide()
        dlg.connect("response", close)
        dlg.show()
'''
    def abt_resp(self, w, r):
        if r == gtk.RESPONSE_CANCEL:
            w.hide()

    ''' load shutdown and reboot time into gtk '''
    def load_wtmp(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str)
        wtmp_color_flag = 0
        if f == 1:
            for content in self.load_wtmp_list[start:]:
                if self.number_for_wtmp >= tmpstart + self.items_one_page:
                    break
                if wtmp_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),_(content.get('action')),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),_(content.get('action')),'#FFFFFF'])
                wtmp_color_flag = ~wtmp_color_flag
                self.number_for_wtmp += 1
        else:
            for content in self.load_wtmp_list[start:end]:
                if wtmp_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),_(content.get('action')),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),_(content.get('action')),'#FFFFFF'])
                wtmp_color_flag = ~wtmp_color_flag
        self.wTree.get_widget("treeview_all").set_model(model)

    ''' load shutdown and reboot times into gtk '''
    def load_times(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str)
        times_color_flag = 0
        if f == 1:
            for l in self.load_times_list[start:]:
                if self.number_for_times >= tmpstart + self.items_one_page:
                    break
                if times_color_flag == 0:
                    model.append([l.get('year'),l.get('month'),l.get('reboot'),l.get('shutdown'),'#F2F2F2'])
                else:
                    model.append([l.get('year'),l.get('month'),l.get('reboot'),l.get('shutdown'),'#FFFFFF'])
                times_color_flag = ~times_color_flag
                self.number_for_times += 1
        else:
            for l in self.load_time_list[start:end]:
                if times_color_flag == 0:
                    model.append([l.get('year'),l.get('month'),l.get('reboot'),l.get('shutdown'),'#F2F2F2'])
                else:
                    model.append([l.get('year'),l.get('month'),l.get('reboot'),l.get('shutdown'),'#FFFFFF'])
                times_color_flag = ~times_color_flag
                self.number_for_times += 1
        self.wTree.get_widget("treeview_times").set_model(model)

    ''' load boot information into gtk '''
    def load_bootlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str)
        boot_color_flag = 0
        if f == 1:
            for content in self.load_boot_list[start:]:
                if self.number_for_boot >= tmpstart + self.items_one_page:
                    break
                if boot_color_flag == 0:
                    model.append([content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('doit'),content.get('msg'),'#FFFFFF'])
                boot_color_flag = ~boot_color_flag
                self.number_for_boot += 1
        else:
            for content in self.load_boot_list[start:end]:
                if boot_color_flag == 0:
                    model.append([content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('doit'),content.get('msg'),'#FFFFFF'])
                boot_color_flag = ~boot_color_flag
        self.wTree.get_widget("treeview_boot").set_model(model)

    ''' load kern information into gtk '''
    def load_kernlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str)
        kern_color_flag = 0
        if f == 1:
            for content in self.load_kern_list[start:]:
                if self.number_for_kern >= tmpstart + self.items_one_page:
                    break
                if kern_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('msg'),'#FFFFFF'])
                kern_color_flag = ~kern_color_flag
                self.number_for_kern += 1
        else:
            for content in self.load_kern_list[start:end]:
                if kern_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('msg'),'#FFFFFF'])
                kern_color_flag = ~kern_color_flag
        self.wTree.get_widget("treeview_kern").set_model(model)

    ''' load dpkg information into gtk '''
    def load_dpkglist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str)
        dpkg_color_flag = 0
        if f == 1:
            for content in self.load_dpkg_list[start:]:
                if self.number_for_dpkg >= tmpstart + self.items_one_page:
                    break
                if dpkg_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('status'),content.get('pkg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('status'),content.get('pkg'),'#FFFFFF'])
                dpkg_color_flag = ~dpkg_color_flag
                self.number_for_dpkg += 1
        else:
            for content in self.load_dpkg_list[start:end]:
                if dpkg_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('status'),content.get('pkg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('status'),content.get('pkg'),'#FFFFFF'])
                dpkg_color_flag = ~dpkg_color_flag
        self.wTree.get_widget("treeview_dpkg").set_model(model)

    ''' load sys information into gtk '''
    def load_syslist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str)
        sys_color_flag = 0
        if f == 1:
            for content in self.load_sys_list[start:]:
                if self.number_for_sys >= tmpstart + self.items_one_page:
                    break
                if sys_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                sys_color_flag = ~sys_color_flag
                self.number_for_sys += 1
        else:
            for content in self.load_sys_list[start:end]:
                if sys_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                sys_color_flag = ~sys_color_flag
        self.wTree.get_widget("treeview_sys").set_model(model)

    ''' load alternatives information into gtk '''
    def load_alterlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str)
        alter_color_flag = 0
        if f == 1:
            for content in self.load_alter_list[start:]:
                if self.number_for_alter >= tmpstart + self.items_one_page:
                    break
                if alter_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('msg'),'#FFFFFF'])
                alter_color_flag = ~alter_color_flag
                self.number_for_alter += 1
        else:
            for content in self.load_alter_list[start:end]:
                if alter_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('msg'),'#FFFFFF'])
                alter_color_flag = ~alter_color_flag
        self.wTree.get_widget("treeview_alter").set_model(model)

    ''' load cups information into gtk '''
    def load_cupslist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str, str)
        cups_color_flag = 0
        if f == 1:
            for content in self.load_cups_list[start:]:
                if self.number_for_cups >= tmpstart + self.items_one_page:
                    break
                if cups_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('host'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('host'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                cups_color_flag = ~cups_color_flag
                self.number_for_cups += 1
        else:
            for content in self.load_cups_list[start:end]:
                if cups_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('host'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('host'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                cups_color_flag = ~cups_color_flag
        self.wTree.get_widget("treeview_cups").set_model(model)

    ''' load brasero information into gtk '''
    def load_braserolist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str)
        brasero_color_flag = 0
        if f == 1:
            for content in self.load_brasero_list[start:]:
                if self.number_for_brasero >= tmpstart + self.items_one_page:
                    break
                if brasero_color_flag == 0:
                    model.append([content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('msg'),'#FFFFFF'])
                brasero_color_flag = ~brasero_color_flag
                self.number_for_brasero += 1
        else:
            for content in self.load_brasero_list[start:end]:
                if brasero_color_flag == 0:
                    model.append([content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('msg'),'#FFFFFF'])
                brasero_color_flag = ~brasero_color_flag
        self.wTree.get_widget("treeview_brasero").set_model(model)

    ''' load audit information into gtk '''
    def load_auditlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str)
        audit_color_flag = 0
        if f == 1:
            for content in self.load_audit_list[start:]:
                if self.number_for_audit >= tmpstart + self.items_one_page:
                    break
                if audit_color_flag == 0:
                    model.append([content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('msg'),'#FFFFFF'])
                audit_color_flag = ~audit_color_flag
                self.number_for_audit += 1
        else:
            for content in self.load_audit_list[start:end]:
                if audit_color_flag == 0:
                    model.append([content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('msg'),'#FFFFFF'])
                audit_color_flag = ~audit_color_flag
        self.wTree.get_widget("treeview_audit").set_model(model)

    ''' load xsession information into gtk '''
    def load_xsessionlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str)
        xsession_color_flag = 0
        if f == 1:
            for content in self.load_xsession_list[start:]:
                if self.number_for_xsession >= tmpstart + self.items_one_page:
                    break
                if xsession_color_flag == 0:
                    model.append([content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('msg'),'#FFFFFF'])
                xsession_color_flag = ~xsession_color_flag
                self.number_for_xsession += 1
        else:
            for content in self.load_xsession_list[start:end]:
                if xsession_color_flag == 0:
                    model.append([content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('msg'),'#FFFFFF'])
                xsession_color_flag = ~xsession_color_flag
        self.wTree.get_widget("treeview_xsession").set_model(model)

    ''' load xorg information into gtk '''
    def load_xorglist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str)
        xorg_color_flag = 0
        if f == 1:
            for content in self.load_xorg_list[start:]:
                if self.number_for_xorg >= tmpstart + self.items_one_page:
                    break
                if xorg_color_flag == 0:
                    model.append([content.get('loadt'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('loadt'),content.get('msg'),'#FFFFFF'])
                xorg_color_flag = ~xorg_color_flag
                self.number_for_xorg += 1
        else:
            for content in self.load_xorg_list[start:end]:
                if xorg_color_flag == 0:
                    model.append([content.get('loadt'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('loadt'),content.get('msg'),'#FFFFFF'])
                xorg_color_flag = ~xorg_color_flag
        self.wTree.get_widget("treeview_xorg").set_model(model)

    ''' load bios information into gtk '''
    def load_bioslist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str)
        bios_color_flag = 0
        if f == 1:
            for content in self.load_bios_list[start:]:
                if self.number_for_bios >= tmpstart + self.items_one_page:
                    break
                if bios_color_flag == 0:
                    model.append([content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('msg'),'#FFFFFF'])
                bios_color_flag = ~bios_color_flag
                self.number_for_bios += 1
        else:
            for content in self.load_bios_list[start:end]:
                if bios_color_flag == 0:
                    model.append([content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('msg'),'#FFFFFF'])
                bios_color_flag = ~bios_color_flag
        self.wTree.get_widget("treeview_bios").set_model(model)

    ''' load sscard information into gtk '''
    def load_sscardlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str)
        sscard_color_flag = 0
        if f == 1:
            for content in self.load_sscard_list[start:]:
                if self.number_for_sscard >= tmpstart + self.items_one_page:
                    break
                if sscard_color_flag == 0:
                    model.append([content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('msg'),'#FFFFFF'])
                sscard_color_flag = ~sscard_color_flag
                self.number_for_sscard += 1
        else:
            for content in self.load_sscard_list[start:end]:
                if sscard_color_flag == 0:
                    model.append([content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('msg'),'#FFFFFF'])
                sscard_color_flag = ~sscard_color_flag
        self.wTree.get_widget("treeview_sscard").set_model(model)

    ''' load debug into gtk '''
    def load_debuglist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str)
        debug_color_flag = 0
        if f == 1:
            for content in self.load_debug_list[start:]:
                if self.number_for_debug >= tmpstart + self.items_one_page:
                    break
                if debug_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                debug_color_flag = ~debug_color_flag
                self.number_for_debug += 1
        else:
            for content in self.load_debug_list[start:end]:
                if debug_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                debug_color_flag = ~debug_color_flag
        self.wTree.get_widget("treeview_debug").set_model(model)

    ''' load info into gtk '''
    def load_infolist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str)
        info_color_flag = 0
        if f == 1:
            for content in self.load_info_list[start:]:
                if self.number_for_info >= tmpstart + self.items_one_page:
                    break
                if info_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                info_color_flag = ~info_color_flag
                self.number_for_info += 1
        else:
            for content in self.load_info_list[start:end]:
                if info_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                info_color_flag = ~info_color_flag
        self.wTree.get_widget("treeview_info").set_model(model)

    ''' load notice into gtk '''
    def load_noticelist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str)
        notice_color_flag = 0
        if f == 1:
            for content in self.load_notice_list[start:]:
                if self.number_for_notice >= tmpstart + self.items_one_page:
                    break
                if notice_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                notice_color_flag = ~notice_color_flag
                self.number_for_notice += 1
        else:
            for content in self.load_notice_list[start:end]:
                if notice_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                notice_color_flag = ~notice_color_flag
        self.wTree.get_widget("treeview_notice").set_model(model)

    ''' load warning into gtk '''
    def load_warninglist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str)
        warning_color_flag = 0
        if f == 1:
            for content in self.load_warning_list[start:]:
                if self.number_for_warning >= tmpstart + self.items_one_page:
                    break
                if warning_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                warning_color_flag = ~warning_color_flag
                self.number_for_warning += 1
        else:
            for content in self.load_debug_list[start:end]:
                if warning_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                warning_color_flag = ~warning_color_flag
        self.wTree.get_widget("treeview_warning").set_model(model)

    ''' load err into gtk '''
    def load_errlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str)
        err_color_flag = 0
        if f == 1:
            for content in self.load_err_list[start:]:
                if self.number_for_err >= tmpstart + self.items_one_page:
                    break
                if err_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                err_color_flag = ~err_color_flag
                self.number_for_err += 1
        else:
            for content in self.load_debug_list[start:end]:
                if err_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                err_color_flag = ~err_color_flag
        self.wTree.get_widget("treeview_err").set_model(model)

    ''' load crit into gtk '''
    def load_critlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str)
        crit_color_flag = 0
        if f == 1:
            for content in self.load_crit_list[start:]:
                if self.number_for_crit >= tmpstart + self.items_one_page:
                    break
                if crit_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                crit_color_flag = ~crit_color_flag
                self.number_for_crit += 1
        else:
            for content in self.load_crit_list[start:end]:
                if crit_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                crit_color_flag = ~crit_color_flag
        self.wTree.get_widget("treeview_crit").set_model(model)

    ''' load alert into gtk '''
    def load_alertlist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str)
        alert_color_flag = 0
        if f == 1:
            for content in self.load_alert_list[start:]:
                if self.number_for_alert >= tmpstart + self.items_one_page:
                    break
                if alert_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                alert_color_flag = ~alert_color_flag
                self.number_for_alert += 1
        else:
            for content in self.load_alert_list[start:end]:
                if alert_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                alert_color_flag = ~alert_color_flag
        self.wTree.get_widget("treeview_alert").set_model(model)

    ''' load emerg into gtk '''
    def load_emerglist(self, f, start, end):
        tmpstart = start
        model = gtk.ListStore(str, str, str, str, str, str)
        emerg_color_flag = 0
        if f == 1:
            for content in self.load_emerg_list[start:]:
                if self.number_for_emerg >= tmpstart + self.items_one_page:
                    break
                if emerg_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                emerg_color_flag = ~emerg_color_flag
                self.number_for_emerg += 1
        else:
            for content in self.load_emerg_list[start:end]:
                if emerg_color_flag == 0:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#F2F2F2'])
                else:
                    model.append([content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg'),'#FFFFFF'])
                emerg_color_flag = ~emerg_color_flag
        self.wTree.get_widget("treeview_emerg").set_model(model)

    def update_pagelabel(self, position ,total):
        page_count = total/self.items_one_page
        if total%self.items_one_page > 0:
            page_count += 1
        current_page = position/self.items_one_page
        if position%self.items_one_page > 0:
            current_page += 1
        self.wTree.get_widget("label_pagenum").set_text(_(str(current_page)+'/'+str(page_count)))

    def update_last_next_button(self, number ,count):
        if count > self.items_one_page:
            if number <= self.items_one_page:
                self.wTree.get_widget("button_lastpage").hide()
                self.wTree.get_widget("button_nextpage").show()
            elif number == count:
                self.wTree.get_widget("button_lastpage").show()
                self.wTree.get_widget("button_nextpage").hide()
            else:
                self.wTree.get_widget("button_lastpage").show()
                self.wTree.get_widget("button_nextpage").show()
        else:
            self.wTree.get_widget("button_nextpage").hide()
            self.wTree.get_widget("button_lastpage").hide()

    def update_year_month(self, year ,month):
        self.wTree.get_widget("combobox_year").set_active(year)
        self.wTree.get_widget("combobox_month").set_active(month)

    def update_keyword(self, keyword):
        key = self.wTree.get_widget("entry_keyword").set_text(keyword)

    '''get filter information'''
    def get_filter_info(self, list_filtered, year, month):
        list_ret = []
        if year == '0':
            if month == '0':
                list_ret = list_filtered[:]
            else:
                for line in list_filtered:
                    if(line.get('date').split('-')[1] == month):
                        list_ret.append(line)
        else:
            if month == '0':
                for line in list_filtered:
                    if(line.get('date').split('-')[0] == year):
                        list_ret.append(line)
            else:
                for line in list_filtered:
                    if(line.get('date').split('-')[0] == year and line.get('date').split('-')[1] == month):
                        list_ret.append(line)
        return list_ret

    '''change page by keyword'''
    def filter_statistics_callback(self, widget):
        key = self.wTree.get_widget("entry_keyword").get_text()
        year_index = self.wTree.get_widget("combobox_year").get_active()
        month_index = self.wTree.get_widget("combobox_month").get_active()
        if self.flag_menu == 0:
            active = self.wTree.get_widget("menu_view").get_active().get_label()
        elif self.flag_menu == 1:
            active = self.wTree.get_widget("menu_analyze").get_active().get_label()
        elif self.flag_menu == 2:
            active = self.wTree.get_widget("menu_level").get_active().get_label()
        month = str(month_index)
        if year_index == 0:
            year = '0'
        else:
            year = self.wtmp_year[year_index-1]
        tmp_count = 0
        tmp_number = 0
        #page for shutdown and reboot time
        if active == _("Last search"):
            del self.load_wtmp_list[:]
            self.keyword_wtmp = key
            #key == reboot
            if unicode(key,'utf8').find(u'\u5f00') != -1:
                key = 'reboot'
            #key == shutdown
            elif unicode(key,'utf8').find(u'\u5173') != -1:
                key = 'shutdown'
            #key == reboot and shutdown
            elif unicode(key,'utf8').find(u'\u673a') != -1:
                key = ''
            #update current item's start position and count for filterd list
            self.load_wtmp_list = self.get_filter_info(self.time_list, year, month)
            self.load_wtmp_list = self.check_parser.check_match_keywords(self.load_wtmp_list, key)
            self.count_for_wtmp = len(self.load_wtmp_list)
            self.number_for_wtmp = 0

            self.wTree.get_widget("treeview_all").get_model().clear()
            self.load_wtmp(f=1, start = 0, end = 0)
            tmp_count = self.count_for_wtmp
            tmp_number = self.number_for_wtmp
            self.year_for_wtmp = year_index
            self.month_for_wtmp = month_index
        #page for shutdown and reboot times
        elif active == _("Times statistics"):
            del self.load_times_list[:]
            self.keyword_times = key
            #update current item's start position and count for filterd list
            self.load_times_list = self.get_filter_info(self.times_for_years, year, month)
            self.load_times_list = self.check_parser.check_match_keywords(self.load_times_list, key)
            self.count_for_times = len(self.load_times_list)
            self.number_for_times = 0

            self.wTree.get_widget("treeview_times").get_model().clear()
            self.load_times(f=1, start = 0, end = 0)
            tmp_count = self.count_for_times
            tmp_number = self.number_for_times
            self.year_for_times = year_index
            self.month_for_times = month_index
        #page for sys
        elif active == _("Sys statistics"):
            del self.load_sys_list[:]
            self.keyword_sys = key
            #update current item's start position and count for filterd list
            self.load_sys_list = self.check_parser.check_match_keywords(self.syslist, key)
            self.count_for_sys = len(self.load_sys_list)
            self.number_for_sys = 0

            self.wTree.get_widget("treeview_sys").get_model().clear()
            self.load_syslist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_sys
            tmp_number = self.number_for_sys
        #page for boot
        elif active == _("Boot statistics"):
            del self.load_boot_list[:]
            self.keyword_boot = key
            #update current item's start position and count for filterd list
            self.load_boot_list = self.check_parser.check_match_keywords(self.bootlist, key)
            self.count_for_boot = len(self.load_boot_list)
            self.number_for_boot = 0

            self.wTree.get_widget("treeview_boot").get_model().clear()
            self.load_bootlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_boot
            tmp_number = self.number_for_boot
        #page for dpkg
        elif active == _("Dpkg statistics"):
            del self.load_dpkg_list[:]
            self.keyword_dpkg = key
            #update current item's start position and count for filterd list
            self.load_dpkg_list = self.check_parser.check_match_keywords(self.dpkglist, key)
            self.count_for_dpkg = len(self.load_dpkg_list)
            self.number_for_dpkg = 0

            self.wTree.get_widget("treeview_dpkg").get_model().clear()
            self.load_dpkglist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_dpkg
            tmp_number = self.number_for_dpkg
        #page for kern
        elif active == _("Kern statistics"):
            del self.load_kern_list[:]
            self.keyword_kern = key
            #update current item's start position and count for filterd list
            self.load_kern_list = self.check_parser.check_match_keywords(self.kernlist, key)
            self.count_for_kern = len(self.load_kern_list)
            self.number_for_kern = 0

            self.wTree.get_widget("treeview_kern").get_model().clear()
            self.load_kernlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_kern
            tmp_number = self.number_for_kern
        #page for alter
        elif active == _("Alternative statistics"):
            del self.load_alter_list[:]
            self.keyword_alter = key
            #update current item's start position and count for filterd list
            self.load_alter_list = self.check_parser.check_match_keywords(self.alterlist, key)
            self.count_for_alter = len(self.load_alter_list)
            self.number_for_alter = 0

            self.wTree.get_widget("treeview_alter").get_model().clear()
            self.load_alterlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_alter
            tmp_number = self.number_for_alter
        #page for cups
        elif active == _("Cups statistics"):
            del self.load_cups_list[:]
            self.keyword_cups = key
            #update current item's start position and count for filterd list
            self.load_cups_list = self.check_parser.check_match_keywords(self.cupslist, key)
            self.count_for_cups = len(self.load_cups_list)
            self.number_for_cups = 0

            self.wTree.get_widget("treeview_cups").get_model().clear()
            self.load_cupslist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_cups
            tmp_number = self.number_for_cups
        #page for brasero
        elif active == _("Brasero statistics"):
            del self.load_brasero_list[:]
            self.keyword_brasero = key
            #update current item's start position and count for filterd list
            self.load_brasero_list = self.check_parser.check_match_keywords(self.braserolist, key)
            self.count_for_brasero = len(self.load_brasero_list)
            self.number_for_brasero = 0

            self.wTree.get_widget("treeview_brasero").get_model().clear()
            self.load_braserolist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_brasero
            tmp_number = self.number_for_brasero
        #page for audit
        elif active == _("Audit statistics"):
            del self.load_audit_list[:]
            self.keyword_audit = key
            #update current item's start position and count for filterd list
            self.load_audit_list = self.check_parser.check_match_keywords(self.auditlist, key)
            self.count_for_audit = len(self.load_audit_list)
            self.number_for_audit = 0

            self.wTree.get_widget("treeview_audit").get_model().clear()
            self.load_auditlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_audit
            tmp_number = self.number_for_audit
        #page for xsession
        elif active == _("Xsession statistics"):
            del self.load_xsession_list[:]
            self.keyword_xsession = key
            #update current item's start position and count for filterd list
            self.load_xsession_list = self.check_parser.check_match_keywords(self.xsessionlist, key)
            self.count_for_xsession = len(self.load_xsession_list)
            self.number_for_xsession = 0

            self.wTree.get_widget("treeview_xsession").get_model().clear()
            self.load_xsessionlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_xsession
            tmp_number = self.number_for_xsession
        #page for xorg
        elif active == _("Xorg statistics"):
            del self.load_xorg_list[:]
            self.keyword_xorg = key
            #update current item's start position and count for filterd list
            self.load_xorg_list = self.check_parser.check_match_keywords(self.xorglist, key)
            self.count_for_xorg = len(self.load_xorg_list)
            self.number_for_xorg = 0

            self.wTree.get_widget("treeview_xorg").get_model().clear()
            self.load_xorglist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_xorg
            tmp_number = self.number_for_xorg
        elif active == _("debug"):
            del self.load_debug_list[:]
            self.keyword_debug = key
            #update current item's start position and count for filterd list
            self.load_debug_list = self.check_parser.check_match_keywords(self.debuglist, key)
            self.count_for_debug = len(self.load_debug_list)
            self.number_for_debug = 0

            self.wTree.get_widget("treeview_debug").get_model().clear()
            self.load_debuglist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_debug
            tmp_number = self.number_for_debug
        elif active == _("info"):
            del self.load_info_list[:]
            self.keyword_info = key
            #update current item's start position and count for filterd list
            self.load_info_list = self.check_parser.check_match_keywords(self.infolist, key)
            self.count_for_info = len(self.load_info_list)
            self.number_for_info = 0

            self.wTree.get_widget("treeview_info").get_model().clear()
            self.load_infolist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_info
            tmp_number = self.number_for_info
        elif active == _("notice"):
            del self.load_notice_list[:]
            self.keyword_notice = key
            #update current item's start position and count for filterd list
            self.load_notice_list = self.check_parser.check_match_keywords(self.noticelist, key)
            self.count_for_notice = len(self.load_notice_list)
            self.number_for_notice = 0

            self.wTree.get_widget("treeview_notice").get_model().clear()
            self.load_noticelist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_notice
            tmp_number = self.number_for_notice
        elif active == _("warning"):
            del self.load_warning_list[:]
            self.keyword_warning = key
            #update current item's start position and count for filterd list
            self.load_warning_list = self.check_parser.check_match_keywords(self.warninglist, key)
            self.count_for_warning = len(self.load_warning_list)
            self.number_for_warning = 0

            self.wTree.get_widget("treeview_warning").get_model().clear()
            self.load_warninglist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_warning
            tmp_number = self.number_for_warning
        elif active == _("err"):
            del self.load_err_list[:]
            self.keyword_err = key
            #update current item's start position and count for filterd list
            self.load_err_list = self.check_parser.check_match_keywords(self.errlist, key)
            self.count_for_err = len(self.load_err_list)
            self.number_for_err = 0

            self.wTree.get_widget("treeview_err").get_model().clear()
            self.load_errlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_err
            tmp_number = self.number_for_err
        elif active == _("crit"):
            del self.load_crit_list[:]
            self.keyword_crit = key
            #update current item's start position and count for filterd list
            self.load_crit_list = self.check_parser.check_match_keywords(self.critlist, key)
            self.count_for_crit = len(self.load_crit_list)
            self.number_for_crit = 0

            self.wTree.get_widget("treeview_crit").get_model().clear()
            self.load_critlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_crit
            tmp_number = self.number_for_crit
        elif active == _("alert"):
            del self.load_alert_list[:]
            self.keyword_alert = key
            #update current item's start position and count for filterd list
            self.load_alert_list = self.check_parser.check_match_keywords(self.alertlist, key)
            self.count_for_alert = len(self.load_alert_list)
            self.number_for_alert = 0

            self.wTree.get_widget("treeview_alert").get_model().clear()
            self.load_alertlist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_alert
            tmp_number = self.number_for_alert
        elif active == _("emerg"):
            del self.load_emerg_list[:]
            self.keyword_emerg = key
            #update current item's start position and count for filterd list
            self.load_emerg_list = self.check_parser.check_match_keywords(self.emerglist, key)
            self.count_for_emerg = len(self.load_emerg_list)
            self.number_for_emerg = 0

            self.wTree.get_widget("treeview_emerg").get_model().clear()
            self.load_emerglist(f=1, start = 0, end = 0)
            tmp_count = self.count_for_emerg
            tmp_number = self.number_for_emerg
        
        if active != _("Last search") and active != _("Times statistics"):
            self.wTree.get_widget("combobox_year").hide()
            self.wTree.get_widget("combobox_month").hide()
            self.wTree.get_widget("label_year").hide()
            self.wTree.get_widget("label_month").hide()
        else:
            self.wTree.get_widget("combobox_year").show()
            self.wTree.get_widget("combobox_month").show()
            self.wTree.get_widget("label_year").show()
            self.wTree.get_widget("label_month").show()

        self.update_last_next_button(tmp_number,tmp_count)
        self.update_pagelabel(tmp_number,tmp_count)

    def export_current_callback(self, widget):
        if self.flag_menu == 0:
            active = self.wTree.get_widget("menu_view").get_active().get_label()
        elif self.flag_menu ==2:
            active = self.wTree.get_widget("menu_level").get_active().get_label()
        desktop_path = os.environ['HOME'] + "/桌面/log"
        print desktop_path
        log_time = time.strftime("%Y-%m-%d-%H:%M:%S-%Z",time.localtime(time.time()))
        print log_time
        message = gtk.MessageDialog(type=gtk.MESSAGE_QUESTION,message_format="日志将导出到桌面，确认导出吗？",buttons=gtk.BUTTONS_OK_CANCEL)
        message.set_default_response(gtk.RESPONSE_OK)
        response = message.run()
        message.destroy()
        if response == gtk.RESPONSE_OK:        
            savepath = desktop_path + log_time
        else:
            savepath = ''
        if len(savepath) != 0:
            f = open(savepath,"w")
            #page for Search            
            if active == _("Last search"):
                start = self.number_for_wtmp - self.items_one_page
                tmp_start_export = start
                for content in self.load_wtmp_list[start:]:
                    if tmp_start_export >= start + self.items_one_page:
                        break
                    print >> f, content.get('date'),content.get('time'),_(content.get('action'))
                    tmp_start_export += 1
            #page for dmsg
            if active == _("Dmesg statistics"):
                start = self.number_for_dmsg - self.items_one_page
                tmp_start_export = start
                for content in self.load_dmsg_list[start:]:
                    if tmp_start_export >= start + self.items_one_page:
                        break
                    print >> f, content.get('loadt'),content.get('msg')
                    tmp_start_export += 1
            #page for auth
            if active == _("Auth statistics"):
                start = self.number_for_auth - self.items_one_page
                tmp_start_export = start
                for content in self.load_auth_list[start:]:
                    if tmp_start_export >= start + self.items_one_page:
                        break
                    print >> f, content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
                    tmp_start_export += 1
            #page for sys
            if active == _("Sys statistics"):
                for content in self.load_sys_list[0:]:
                    print >> f, content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            #page for boot
            if active == _("Boot statistics"):
                start = self.number_for_boot - self.items_one_page
                tmp_start_export = start
                for content in self.load_boot_list[start:]:
                    if tmp_start_export >= start + self.items_one_page:
                        break
                    print >> f, content.get('doit'),content.get('msg')
                    tmp_start_export += 1
            #page for dpkg
            if active == _("Dpkg statistics"):
                start = self.number_for_dpkg - self.items_one_page
                tmp_start_export = start
                for content in self.load_dpkg_list[start:]:
                    if tmp_start_export >= start + self.items_one_page:
                        break
                    print >> f, content.get('date'),content.get('time'),content.get('status'),content.get('pkg')
                    tmp_start_export += 1
            #page for kern
            if active == _("Kern statistics"):
                start = self.number_for_kern - self.items_one_page
                tmp_start_export = start
                for content in self.load_kern_list[start:]:
                    if tmp_start_export >= start + self.items_one_page:
                        break
                    print >> f, content.get('date'),content.get('time'),content.get('user'),content.get('msg')
                    tmp_start_export += 1
            #page for alternative
            if active == _("Alternative statistics"):
                start = self.number_for_alter - self.items_one_page
                tmp_start_export = start
                for content in self.load_alter_list[start:]:
                    if tmp_start_export >= start + self.items_one_page:
                        break
                    print >> f, content.get('date'),content.get('time'),content.get('msg')
                    tmp_start_export += 1
            #page for cups
            if active == _("Cups statistics"):
                start = self.number_for_cups - self.items_one_page
                tmp_start_export = start
                for content in self.load_cups_list[start:]:
                    if tmp_start_export >= start + self.items_one_page:
                        break
                    print >> f, content.get('date'),content.get('time'),content.get('host'),content.get('user'),content.get('doit'),content.get('msg')
                    tmp_start_export += 1
            #page for Brasero
            if active == _("Brasero statistics"):
                for content in self.load_brasero_list[0:]:
                    print >> f, content.get('msg')
            #page for audit
            if active == _("Audit statistics"):
                for content in self.load_audit_list[0:]:
                    print >> f, content.get('msg')
            #page for xsession
            if active == _("Xsession statistics"):
                for content in self.load_xsession_list[0:]:
                    print >> f, content.get('msg')
            #page for ufw
            if active == _("Ufw statistics"):
                start = self.number_for_ufw - self.items_one_page
                tmp_start_export = start
                for content in self.load_ufw_list[start:]:
                    if tmp_start_export >= start + self.items_one_page:
                        break
                    print >> f, (content.get('date'),content.get('time'),content.get('user'),content.get('incard'),
                                  content.get('outcard'),content.get('mac'),content.get('src'),content.get('dest'),
                                  content.get('len'),content.get('id'),content.get('proto'),content.get('spt'),
                                  content.get('dpt'),content.get('window'))
                    tmp_start_export += 1
            #page for fail
            if active == _("Fail statistics"):
                start = self.number_for_fail - self.items_one_page
                tmp_start_export = start
                for content in self.load_fail_list[start:]:
                    if tmp_start_export >= start + self.items_one_page:
                        break
                    print >> f, content.get('user'),content.get('ftimes'),content.get('date'),content.get('time')
                    tmp_start_export += 1
            #page for xorg
            if active == _("Xorg statistics"):
                start = self.number_for_xorg - self.items_one_page
                tmp_start_export = start
                for content in self.load_xorg_list[start:]:
                    if tmp_start_export >= start + self.items_one_page:
                        break
                    print >> f, content.get('loadt'),content.get('msg')
                    tmp_start_export += 1
            #page for bios
            if active == _("Bios audit statistics"):
                for content in self.load_bios_list[0:]:
                    print >> f, content.get('msg')
            #page for sscard
            if active == _("Sscard statistics"):
                for content in self.load_sscard_list[0:]:
                    print >> f, content.get('msg')
            #page for debug
            if active == _("debug"):
                for content in self.load_debug_list[0:]:
                    print >> f, content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            #page for debug
            if active == _("info"):
                for content in self.load_info_list[0:]:
                    print >> f, content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            #page for debug
            if active == _("notice"):
                for content in self.load_notice_list[0:]:
                    print >> f, content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            #page for debug
            if active == _("warning"):
                for content in self.load_warning_list[0:]:
                    print >> f, content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            #page for debug
            if active == _("err"):
                for content in self.load_err_list[0:]:
                    print >> f, content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            #page for debug
            if active == _("crit"):
                for content in self.load_crit_list[0:]:
                    print >> f, content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            #page for debug
            if active == _("alert"):
                for content in self.load_alert_list[0:]:
                    print >> f, content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            #page for debug
            if active == _("emerg"):
                for content in self.load_emerg_list[0:]:
                    print >> f, content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()

        else:
            print "cancelled export current..."

    def export_all_callback(self,widget):
        #parser for logs
        parser = Parser_LPMT.Parser_LPMT()
        self.check_parser = Check_LPMT.Check_LPMT()

        desktop_path = os.environ['HOME'] + "/桌面/log"
        print desktop_path
        log_time = time.strftime("%Y-%m-%d-%H:%M:%S-%Z",time.localtime(time.time()))
        print log_time
        message = gtk.MessageDialog(type=gtk.MESSAGE_QUESTION,message_format="日志将导出到桌面，确认导出吗？",buttons=gtk.BUTTONS_OK_CANCEL)
        message.set_default_response(gtk.RESPONSE_OK)
        response = message.run()
        message.destroy()
        if response == gtk.RESPONSE_OK:        
            savepath = desktop_path + log_time + ".zip"
        else:
            savepath = ''

        if len(savepath) !=0:
            os.system("rm -rf /tmp/export/*");
            os.system("mkdir -p /tmp/export/");
            #导出wtmp
            f = open("/tmp/export/wtmp.log","w")
            for content in self.load_wtmp_list:
                print >> f,content.get('date'),content.get('time'),_(content.get('action'))
            f.close()
            #导出times
            f = open("/tmp/export/times.log","w")
            for content in self.load_times_list:
                print >> f,content.get('year'),content.get('month'),content.get('reboot'),content.get('shutdown')
            f.close()
            #导出auth
            if not self.parse_auth_flag:
                #get information of auth.log
                self.authlist = parser.parser_all_auth_log()
                self.count_for_auth = len(self.authlist)
                self.load_auth_list = self.authlist[:]
                self.parse_auth_flag = 1
            f = open("/tmp/export/auth.log","w")
            for content in self.load_auth_list:
                print >> f,content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()
            #导出sys
            if not self.parse_sys_flag:
                #get information of syslog
                self.syslist = parser.parser_all_sys_log()
                self.count_for_sys = len(self.syslist)
                self.load_sys_list = self.syslist[:]
                self.parse_sys_flag = 1
            f = open("/tmp/export/syslog.log","w")
            for content in self.load_sys_list:
                print >> f,content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()
            #导出boot
            if not self.parse_boot_flag:
                #get information of boot.log
                self.bootlist = parser.parser_all_boot_log()
                self.count_for_boot = len(self.bootlist)
                self.load_boot_list = self.bootlist[:]
                self.parse_boot_flag = 1
            f = open("/tmp/export/boot.log","w")
            for content in self.load_boot_list:
                print >> f,content.get('doit'),content.get('msg')
            f.close()
            #导出dpkg
            if not self.parse_dpkg_flag:
                #get information of dpkg.log
                self.dpkglist = parser.parser_all_dpkg_log()
                self.count_for_dpkg = len(self.dpkglist)
                self.load_dpkg_list = self.dpkglist[:]
                self.parse_dpkg_flag = 1
            f = open("/tmp/export/dpkg.log","w")
            for content in self.load_dpkg_list:
                print >> f,content.get('date'),content.get('time'),content.get('status'),content.get('pkg')
            f.close()
            #导出kern
            if not self.parse_kern_flag:
                #get information of kern.log
                self.kernlist = parser.parser_all_kern_log()
                self.count_for_kern = len(self.kernlist)
                self.load_kern_list = self.kernlist[:]
                self.parse_kern_flag = 1
            f = open("/tmp/export/kern.log","w")
            for content in self.load_kern_list:
                print >> f,content.get('date'),content.get('time'),content.get('user'),content.get('msg')
            f.close()
            #导出alter
            if not self.parse_alter_flag:
                #get information of alternatives.log
                self.alterlist = parser.parser_all_alter_log()
                self.count_for_alter = len(self.alterlist)
                self.load_alter_list = self.alterlist[:]
                self.parse_alter_flag = 1
            f = open("/tmp/export/alter.log","w")
            for content in self.load_alter_list:
                print >> f,content.get('date'),content.get('time'),content.get('msg')
            f.close()
            #导出cups
            if not self.parse_cups_flag:
                #get information of cups
                self.cupslist = parser.parser_all_cups_log()
                self.count_for_cups = len(self.cupslist)
                self.load_cups_list = self.cupslist[:]
                self.parse_cups_flag = 1
            f = open("/tmp/export/cups.log","w")
            for content in self.load_cups_list:
                print >> f,content.get('date'),content.get('time'),content.get('host'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()
            #导出brasero
            if not self.parse_brasero_flag:
                #get information of cups
                self.braserolist = parser.parser_all_brasero_log()
                self.count_for_brasero = len(self.braserolist)
                self.load_brasero_list = self.braserolist[:]
                self.parse_brasero_flag = 1
            f = open("/tmp/export/brasero.log","w")
            for content in self.load_brasero_list:
                print >> f,content.get('msg')
            f.close()
            #导出audit
            if not self.parse_audit_flag:
                #get information of audit
                self.auditlist = parser.parser_all_audit_log()
                self.count_for_audit = len(self.auditlist)
                self.load_audit_list = self.auditlist[:]
                self.parse_audit_flag = 1
            f = open("/tmp/export/audit.log","w")
            for content in self.load_audit_list:
                print >> f,content.get('date'),content.get('time'),content.get('host'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()
            #导出xsession
            if not self.parse_xsession_flag:
                #get information of xsession
                self.xsessionlist = parser.parser_all_xsession_log()
                self.count_for_xsession = len(self.xsessionlist)
                self.load_xsession_list = self.xsessionlist[:]
                self.parse_xsession_flag = 1
            f = open("/tmp/export/xsession.log","w")
            for content in self.load_xsession_list:
                print >> f,content.get('date'),content.get('time'),content.get('host'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()
            #导出ufw

            #导出fail
            if not self.parse_fail_flag:
                #get information of faillog
                self.faillist = parser.parser_all_fail_log()
                self.count_for_fail = len(self.faillist)
                self.load_fail_list = self.faillist[:]
                self.parse_fail_flag = 1
            f = open("/tmp/export/fail.log","w")
            for content in self.load_fail_list:
                print >> f,content.get('user'),content.get('ftimes'),content.get('date'),content.get('time')
            f.close()
            #导出xorg
            if not self.parse_xorg_flag:
                #get information of xorglog
                self.xorglist = parser.parser_all_xorg_log()
                self.count_for_xorg = len(self.xorglist)
                self.load_xorg_list = self.xorglist[:]
                self.parse_xorg_flag = 1
            f = open("/tmp/export/xorg.log","w")
            for content in self.load_xorg_list:
                print >> f,content.get('loadt'),content.get('msg')
            f.close()
            zy_path = "/var/log/sscard/.scdlog"
            if os.path.exists(zy_path):
                #导出Bios
                if not self.parse_bios_flag:
                    #get information of xorglog
                    self.bioslist = parser.parser_all_bios_log()
                    self.count_for_bios = len(self.bioslist)
                    self.load_bios_list = self.bioslist[:]
                    self.parse_bios_flag = 1
                f = open("/tmp/export/bios.log","w")
                for content in self.load_bios_list:
                    print >> f,content.get('msg')
                f.close()
                #导出Sscard
                if not self.parse_sscard_flag:
                    #get information of sscard
                    self.sscardlist = parser.parser_all_sscard_log()
                    self.count_for_sscard = len(self.sscardlist)
                    self.load_sscard_list = self.sscardlist[:]
                    self.parse_sscard_flag = 1
                f = open("/tmp/export/sscard.log","w")
                for content in self.load_sscard_list:
                    print >> f,content.get('msg')
                f.close()
            #导出debug
            if not self.parse_level_debug_flag:
                #get information of debug
                self.debuglist = parser.parser_all_debug_log()
                self.count_for_debug = len(self.debuglist)
                self.load_debug_list = self.debuglist[:]
                self.parse_level_debug_flag = 1
            f = open("/tmp/export/debug.log","w")
            for content in self.load_debug_list:
                print >> f,content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()
            #导出info
            if not self.parse_level_info_flag:
                #get information of info
                self.infolist = parser.parser_all_info_log()
                self.count_for_info = len(self.infolist)
                self.load_info_list = self.infolist[:]
                self.parse_level_info_flag = 1
            f = open("/tmp/export/info.log","w")
            for content in self.load_info_list:
                print >> f,content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()
            #导出notice
            if not self.parse_level_notice_flag:
                #get information of notice
                self.noticelist = parser.parser_all_notice_log()
                self.count_for_notice = len(self.noticelist)
                self.load_notice_list = self.noticelist[:]
                self.parse_level_notice_flag = 1
            f = open("/tmp/export/notice.log","w")
            for content in self.load_notice_list:
                print >> f,content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()
            #导出warning
            if not self.parse_level_warning_flag:
                #get information of warning
                self.warninglist = parser.parser_all_warning_log()
                self.count_for_warning = len(self.warninglist)
                self.load_warning_list = self.warninglist[:]
                self.parse_level_warning_flag = 1
            f = open("/tmp/export/warning.log","w")
            for content in self.load_warning_list:
                print >> f,content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()
            #导出err
            if not self.parse_level_err_flag:
                #get information of err
                self.errlist = parser.parser_all_err_log()
                self.count_for_err = len(self.errlist)
                self.load_err_list = self.errlist[:]
                self.parse_level_err_flag = 1
            f = open("/tmp/export/err.log","w")
            for content in self.load_err_list:
                print >> f,content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()
            #导出crit
            if not self.parse_level_crit_flag:
                #get information of crit
                self.critlist = parser.parser_all_crit_log()
                self.count_for_crit = len(self.critlist)
                self.load_crit_list = self.critlist[:]
                self.parse_level_crit_flag = 1
            f = open("/tmp/export/crit.log","w")
            for content in self.load_crit_list:
                print >> f,content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()
            #导出alert
            if not self.parse_level_alert_flag:
                #get information of alert
                self.alertlist = parser.parser_all_alert_log()
                self.count_for_debug = len(self.alertlist)
                self.load_alert_list = self.alertlist[:]
                self.parse_level_alert_flag = 1
            f = open("/tmp/export/alert.log","w")
            for content in self.load_alert_list:
                print >> f,content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()
            #导出emerg
            if not self.parse_level_emerg_flag:
                #get information of emerg
                self.emerglist = parser.parser_all_emerg_log()
                self.count_for_emerg = len(self.emerglist)
                self.load_emerg_list = self.emerglist[:]
                self.parse_level_emerg_flag = 1
            f = open("/tmp/export/emerg.log","w")
            for content in self.load_emerg_list:
                print >> f,content.get('date'),content.get('time'),content.get('user'),content.get('doit'),content.get('msg')
            f.close()

            out_path = '/tmp/export/'
            zip_1 = zipfile.ZipFile(savepath,'w')
            for f in os.listdir(out_path):
                zip_1.write(os.path.join(out_path,f),f,zipfile.ZIP_DEFLATED)
            zip_1.close()
            
        else:
            print "cancelled export all..."

    '''change page'''
    def change_notebook(self, widget):
        #parser for logs
        parser = Parser_LPMT.Parser_LPMT()
        self.check_parser = Check_LPMT.Check_LPMT()

        active = widget.get_label()
        tmp_count = 0
        tmp_number = 0
        year = 0
        month = 0
        key = ''
        #page for shutdown and reboot time
        if active == _("Last search"):
            self.wTree.get_widget("notebook").set_current_page(0)
            self.flag_menu = 0
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("Last search"))
            tmp_count = self.count_for_wtmp
            tmp_number = self.number_for_wtmp
            year = self.year_for_wtmp
            month = self.month_for_wtmp
            key = self.keyword_wtmp
        #page for shutdown and reboot times
        elif active == _("Times statistics"):
            self.wTree.get_widget("notebook").set_current_page(1)
            self.flag_menu = 1
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("Times statistics"))
            tmp_count = self.count_for_times
            tmp_number = self.number_for_times
            year = self.year_for_times
            month = self.month_for_times
            key = self.keyword_times
        #page for sys
        elif active == _("Sys statistics"):
            if not self.parse_sys_flag:
                #get information of syslog
                self.syslist = parser.parser_all_sys_log()
                self.count_for_sys = len(self.syslist)
                self.load_sys_list = self.syslist[:]
                self.parse_sys_flag = 1
            self.wTree.get_widget("notebook").set_current_page(2)
            self.flag_menu = 0
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("Sys statistics"))
            if not self.load_sys_flag:
                self.load_syslist(1,start = tmp_number, end = 0)
                self.load_sys_flag = 1
            tmp_count = self.count_for_sys
            tmp_number = self.number_for_sys
            key = self.keyword_sys
        #page for boot
        elif active == _("Boot statistics"):
            if not self.parse_boot_flag:
                #get information of boot.log
                self.bootlist = parser.parser_all_boot_log()
                self.count_for_boot = len(self.bootlist)
                self.load_boot_list = self.bootlist[:]
                self.parse_boot_flag = 1
            self.wTree.get_widget("notebook").set_current_page(3)
            self.flag_menu = 0
            self.items_one_page = self.item_count2
            self.wTree.get_widget("label_logtitle").set_text(_("Boot statistics"))
            if not self.load_boot_flag:
                self.load_bootlist(1,start = tmp_number, end = 0)
                self.load_boot_flag = 1
            tmp_count = self.count_for_boot
            tmp_number = self.number_for_boot
            key = self.keyword_boot
        #page for dpkg
        elif active == _("Dpkg statistics"):
            if not self.parse_dpkg_flag:
                #get information of dpkg.log
                self.dpkglist = parser.parser_all_dpkg_log()
                self.count_for_dpkg = len(self.dpkglist)
                self.load_dpkg_list = self.dpkglist[:]
                self.parse_dpkg_flag = 1
            self.wTree.get_widget("notebook").set_current_page(4)
            self.flag_menu = 0
            self.items_one_page = self.item_count2
            self.wTree.get_widget("label_logtitle").set_text(_("Dpkg statistics"))
            if not self.load_dpkg_flag:
                self.load_dpkglist(1,start = tmp_number, end = 0)
                self.load_dpkg_flag = 1
            tmp_count = self.count_for_dpkg
            tmp_number = self.number_for_dpkg
            key = self.keyword_dpkg
        #page for kern
        elif active == _("Kern statistics"):
            if not self.parse_kern_flag:
                #get information of kern.log
                self.kernlist = parser.parser_all_kern_log()
                self.count_for_kern = len(self.kernlist)
                self.load_kern_list = self.kernlist[:]
                self.parse_kern_flag = 1
            self.wTree.get_widget("notebook").set_current_page(5)
            self.flag_menu = 0
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("Kern statistics"))
            if not self.load_kern_flag:
                self.load_kernlist(1,start = tmp_number, end = 0)
                self.load_kern_flag = 1
            tmp_count = self.count_for_kern
            tmp_number = self.number_for_kern
            key = self.keyword_kern
        #page for alter
        elif active == _("Alternative statistics"):
            if not self.parse_alter_flag:
                #get information of alternatives.log
                self.alterlist = parser.parser_all_alter_log()
                self.count_for_alter = len(self.alterlist)
                self.load_alter_list = self.alterlist[:]
                self.parse_alter_flag = 1
            self.wTree.get_widget("notebook").set_current_page(6)
            self.flag_menu = 0
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("Alternative statistics"))
            if not self.load_alter_flag:
                self.load_alterlist(1,start = tmp_number, end = 0)
                self.load_alter_flag = 1
            tmp_count = self.count_for_alter
            tmp_number = self.number_for_alter
            key = self.keyword_alter
        #page for cups
        elif active == _("Cups statistics"):
            if not self.parse_cups_flag:
                #get information of cups
                self.cupslist = parser.parser_all_cups_log()
                self.count_for_cups = len(self.cupslist)
                self.load_cups_list = self.cupslist[:]
                self.parse_cups_flag = 1
            self.wTree.get_widget("notebook").set_current_page(7)
            self.flag_menu = 0
            self.wTree.get_widget("label_logtitle").set_text(_("Cups statistics"))
            self.items_one_page = self.item_count1
            if not self.load_cups_flag:
                self.load_cupslist(1,start = tmp_number, end = 0)
                self.load_cups_flag = 1
            tmp_count = self.count_for_cups
            tmp_number = self.number_for_cups
            key = self.keyword_cups
        #page for Brasero 8
        elif active == _("Brasero statistics"):
            if not self.parse_brasero_flag:
                #get information of brasero
                self.braserolist = parser.parser_all_brasero_log()
                self.count_for_brasero = len(self.braserolist)
                self.load_brasero_list = self.braserolist[:]
                self.parse_brasero_flag = 1
            self.wTree.get_widget("notebook").set_current_page(8)
            self.flag_menu = 0
            self.wTree.get_widget("label_logtitle").set_text(_("Brasero statistics"))
            self.items_one_page = self.item_count1
            if not self.load_brasero_flag:
                self.load_braserolist(1,start = tmp_number, end = 0)
                self.load_brasero_flag = 1
            tmp_count = self.count_for_brasero
            tmp_number = self.number_for_brasero
            key = self.keyword_brasero
        #page for Audit 9
        elif active == _("Audit statistics"):
            if not self.parse_audit_flag:
                #get information of audit
                self.auditlist = parser.parser_all_audit_log()
                self.count_for_audit = len(self.auditlist)
                self.load_audit_list = self.auditlist[:]
                self.parse_audit_flag = 1
            self.wTree.get_widget("notebook").set_current_page(9)
            self.flag_menu = 0
            self.wTree.get_widget("label_logtitle").set_text(_("Audit statistics"))
            self.items_one_page = self.item_count1
            if not self.load_audit_flag:
                self.load_auditlist(1,start = tmp_number, end = 0)
                self.load_audit_flag = 1
            tmp_count = self.count_for_audit
            tmp_number = self.number_for_audit
            key = self.keyword_audit
        #page for Xsession 10
        elif active == _("Xsession statistics"):
            if not self.parse_xsession_flag:
                #get information of xsession
                self.xsessionlist = parser.parser_all_xsession_log()
                self.count_for_xsession = len(self.xsessionlist)
                self.load_xsession_list = self.xsessionlist[:]
                self.parse_xsession_flag = 1
            self.wTree.get_widget("notebook").set_current_page(10)
            self.flag_menu = 0
            self.wTree.get_widget("label_logtitle").set_text(_("Xsession statistics"))
            self.items_one_page = self.item_count1
            if not self.load_xsession_flag:
                self.load_xsessionlist(1,start = tmp_number, end = 0)
                self.load_xsession_flag = 1
            tmp_count = self.count_for_xsession
            tmp_number = self.number_for_xsession
            key = self.keyword_xsession
        #page for xorg
        elif active == _("Xorg statistics"):
            if not self.parse_xorg_flag:
                #get information of xorglog
                self.xorglist = parser.parser_all_xorg_log()
                self.count_for_xorg = len(self.xorglist)
                self.load_xorg_list = self.xorglist[:]
                self.parse_xorg_flag = 1
            self.wTree.get_widget("notebook").set_current_page(11)
            self.flag_menu = 0
            self.wTree.get_widget("label_logtitle").set_text(_("Xorg statistics"))
            self.items_one_page = self.item_count1
            if not self.load_xorg_flag:
                self.load_xorglist(1,start = tmp_number, end = 0)
                self.load_xorg_flag = 1
            tmp_count = self.count_for_xorg
            tmp_number = self.number_for_xorg
            key = self.keyword_xorg
        #page for bios audit
        elif active == _("Bios audit statistics"):
            if not self.parse_bios_flag:
                #get information of xorglog
                self.bioslist = parser.parser_all_bios_log()
                self.count_for_bois = len(self.bioslist)
                self.load_bios_list = self.bioslist[:]
                self.parse_bios_flag = 1
            self.wTree.get_widget("notebook").set_current_page(12)
            self.flag_menu = 0
            self.wTree.get_widget("label_logtitle").set_text(_("Bios audit statistics"))
            self.items_one_page = self.item_count1
            if not self.load_bios_flag:
                self.load_bioslist(1,start = tmp_number, end = 0)
                self.load_bios_flag = 1
            tmp_count = self.count_for_bios
            tmp_number = self.number_for_bios
            key = self.keyword_bios
        #page for sscard
        elif active == _("Sscard statistics"):
            if not self.parse_xorg_flag:
                #get information of sscard
                self.sscardlist = parser.parser_all_sscard_log()
                self.count_for_sscard = len(self.sscardlist)
                self.load_sscard_list = self.sscardlist[:]
                self.parse_sscard_flag = 1
            self.wTree.get_widget("notebook").set_current_page(13)
            self.flag_menu = 0
            self.wTree.get_widget("label_logtitle").set_text(_("Sscard statistics"))
            self.items_one_page = self.item_count1
            if not self.load_sscard_flag:
                self.load_sscardlist(1,start = tmp_number, end = 0)
                self.load_sscard_flag = 1
            tmp_count = self.count_for_sscard
            tmp_number = self.number_for_sscard
            key = self.keyword_sscard

        elif active == _("debug"):
            if not self.parse_level_debug_flag:
                #get information of debug
                self.debuglist = parser.parser_all_debug_log()
                self.count_for_debug = len(self.debuglist)
                self.load_debug_list = self.debuglist[:]
                self.parse_level_debug_flag = 1
            self.wTree.get_widget("notebook").set_current_page(14)
            self.flag_menu = 2
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("debug"))
            if not self.load_debug_flag:
                self.load_debuglist(1,start = tmp_number, end = 0)
                self.load_debug_flag = 1
            tmp_count = self.count_for_debug
            tmp_number = self.number_for_debug
            key = self.keyword_debug

        elif active == _("info"):
            if not self.parse_level_info_flag:
                #get information of info
                self.infolist = parser.parser_all_info_log()
                self.count_for_info = len(self.infolist)
                self.load_info_list = self.infolist[:]
                self.parse_level_info_flag = 1
            self.wTree.get_widget("notebook").set_current_page(15)
            self.flag_menu = 2
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("info"))
            if not self.load_info_flag:
                self.load_infolist(1,start = tmp_number, end = 0)
                self.load_info_flag = 1
            tmp_count = self.count_for_info
            tmp_number = self.number_for_info
            key = self.keyword_info

        elif active == _("notice"):
            if not self.parse_level_notice_flag:
                #get information of notice
                self.noticelist = parser.parser_all_notice_log()
                self.count_for_notice = len(self.noticelist)
                self.load_notice_list = self.noticelist[:]
                self.parse_level_notice_flag = 1
            self.wTree.get_widget("notebook").set_current_page(16)
            self.flag_menu = 2
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("notice"))
            if not self.load_notice_flag:
                self.load_noticelist(1,start = tmp_number, end = 0)
                self.load_notice_flag = 1
            tmp_count = self.count_for_notice
            tmp_number = self.number_for_notice
            key = self.keyword_notice

        elif active == _("warning"):
            if not self.parse_level_warning_flag:
                #get information of warning
                self.warninglist = parser.parser_all_warning_log()
                self.count_for_warning = len(self.warninglist)
                self.load_warning_list = self.warninglist[:]
                self.parse_level_warning_flag = 1
            self.wTree.get_widget("notebook").set_current_page(17)
            self.flag_menu = 2
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("warning"))
            if not self.load_warning_flag:
                self.load_warninglist(1,start = tmp_number, end = 0)
                self.load_warning_flag = 1
            tmp_count = self.count_for_warning
            tmp_number = self.number_for_warning
            key = self.keyword_warning

        elif active == _("err"):
            if not self.parse_level_err_flag:
                #get information of err
                self.errlist = parser.parser_all_err_log()
                self.count_for_err = len(self.errlist)
                self.load_err_list = self.errlist[:]
                self.parse_level_err_flag = 1
            self.wTree.get_widget("notebook").set_current_page(18)
            self.flag_menu = 2
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("err"))
            if not self.load_err_flag:
                self.load_errlist(1,start = tmp_number, end = 0)
                self.load_err_flag = 1
            tmp_count = self.count_for_err
            tmp_number = self.number_for_err
            key = self.keyword_err

        elif active == _("crit"):
            if not self.parse_level_crit_flag:
                #get information of crit
                self.critlist = parser.parser_all_crit_log()
                self.count_for_crit = len(self.critlist)
                self.load_crit_list = self.critlist[:]
                self.parse_level_crit_flag = 1
            self.wTree.get_widget("notebook").set_current_page(19)
            self.flag_menu = 2
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("crit"))
            if not self.load_crit_flag:
                self.load_critlist(1,start = tmp_number, end = 0)
                self.load_crit_flag = 1
            tmp_count = self.count_for_crit
            tmp_number = self.number_for_crit
            key = self.keyword_crit

        elif active == _("alert"):
            if not self.parse_level_alert_flag:
                #get information of alert
                self.alertlist = parser.parser_all_alert_log()
                self.count_for_alert = len(self.alertlist)
                self.load_alert_list = self.alertlist[:]
                self.parse_level_alert_flag = 1
            self.wTree.get_widget("notebook").set_current_page(20)
            self.flag_menu = 2
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("alert"))
            if not self.load_alert_flag:
                self.load_alertlist(1,start = tmp_number, end = 0)
                self.load_alert_flag = 1
            tmp_count = self.count_for_alert
            tmp_number = self.number_for_alert
            key = self.keyword_alert

        elif active == _("emerg"):
            if not self.parse_level_emerg_flag:
                #get information of emerg
                self.emerglist = parser.parser_all_emerg_log()
                self.count_for_emerg = len(self.emerglist)
                self.load_emerg_list = self.emerglist[:]
                self.parse_level_emerg_flag = 1
            self.wTree.get_widget("notebook").set_current_page(21)
            self.flag_menu = 2
            self.items_one_page = self.item_count1
            self.wTree.get_widget("label_logtitle").set_text(_("emerg"))
            if not self.load_emerg_flag:
                self.load_emerglist(1,start = tmp_number, end = 0)
                self.load_emerg_flag = 1
            tmp_count = self.count_for_emerg
            tmp_number = self.number_for_emerg
            key = self.keyword_emerg

        if active != _("Last search") and active != _("Times statistics"):
            self.wTree.get_widget("combobox_year").hide()
            self.wTree.get_widget("combobox_month").hide()
            self.wTree.get_widget("label_year").hide()
            self.wTree.get_widget("label_month").hide()
        else:
            self.wTree.get_widget("combobox_year").show()
            self.wTree.get_widget("combobox_month").show()
            self.wTree.get_widget("label_year").show()
            self.wTree.get_widget("label_month").show()
        if active == _("Times statistics"):
            self.wTree.get_widget("button_export_current").hide()
            self.wTree.get_widget("button_export_all").hide()
        else:
            self.wTree.get_widget("button_export_current").show()
            self.wTree.get_widget("button_export_all").show()

        self.update_keyword(key)
        self.update_year_month(year ,month)
        self.update_last_next_button(tmp_number,tmp_count)
        self.update_pagelabel(tmp_number,tmp_count)

    def export_logs(self, zip_name, src_path):
        log_time = time.strftime("%Y-%m-%d-%H:%M:%S-%Z",time.localtime(time.time()))
        message = gtk.MessageDialog(type=gtk.MESSAGE_QUESTION,message_format="日志将导出到桌面，确认导出吗？",buttons=gtk.BUTTONS_OK_CANCEL)
        message.set_default_response(gtk.RESPONSE_OK)
        response = message.run()
        message.destroy()
        if response == gtk.RESPONSE_OK:
            self.zip_filename = zip_name + "-" + log_time + ".zip"
        else:
            self.zip_filename = ''

        if self.zip_filename != '':
            user_name=os.environ['USER']
            status=self.lpmt_dbus.exportLogs(user_name, self.zip_filename, src_path, dbus_interface='com.nfs.LpmtService')
            if status == "exporting":
                self.show_loding_win()
            else:
                message = gtk.MessageDialog(type=gtk.MESSAGE_ERROR,message_format="日志导出失败！",buttons=gtk.BUTTONS_CLOSE)
                response = message.run()
                message.destroy()
            self.loading_win.connect("destroy", self.show_export_win)

    def handle_export_success(self):
        dest_path=os.environ['HOME'] + "/桌面"
        shutil.move(os.path.join("/tmp",self.zip_filename),dest_path)
        self.export_result = True
        self.loading_win.destroy()

    def handle_export_failed(self):
        self.export_result = False
        self.loading_win.destroy()

    # 导出系统所有日志
    def export_all_system_logs(self,widget):
        src_path = ["/var/log", "/var/crash"]
        self.export_logs("log-system", src_path)

    # 导出打印相关日志
    def export_all_print_logs(self,widget):
        src_path = ["/var/log/cups", "/etc/cups"]
        self.export_logs("log-cups", src_path)

if __name__ == "__main__":
    gtk.gdk.threads_init()
    l = LPMT()
    thread.start_new_thread(l.do_main_window_init,())
    gtk.main()
